function [bq,BX]=betaR2tanVecsComps(bR,dimC,X)
%
%
nbR=length(bR);
if mod(nbR,2*dimC) ~= 0
    error('Input vector bR must have a multiple of 2*dimC number of components');
end

[nSubj,cov_num]=size(X);

if nbR/(2*dimC) ~= 1+cov_num
    error('Length of the input vector bR is not consistent with number of covariates');
end

bC=reshape(bR,2,[]).'*[1;1i];
nbC=length(bC);
bq=bC(1:dimC);
bC(1:dimC)=[];
B=reshape(bC,dimC,[]);
BX=B*X.';
end


