function yprime=db0_dsp_z0_zqBeta0(b,z0,ZbC,v)
% derivative of beta0 --> sp(z0,zq(beta0),v)
% where zq(beta0)=exp2DshapesC(z0,Zbc*(beta0(:)));

% works for v vector not; later it will be implemented to work column-wise
% on matrices

b=b(:);
yprime=zeros(length(z0),length(b));
b_norm=norm(b);
v_ZbCcomps=ZbC'*v;
if norm(b) ~= 0
    bC=reshape(b,2,[]).'*[1;1i];
    yp1=-sin(b_norm)*(z0'*v)-msin_prime(b_norm)*(bC'*v_ZbCcomps); %% scalar
    yp1=yp1*(b.')/b_norm;  %% 1 x dM = 1 x length(b) vector
    yp2=msin_prime(b_norm)*(z0'*v)-mcos_prime(b_norm)*(bC'*v_ZbCcomps); %% scalar
    yp2=yp2*(b.')/b_norm;  %% 1 x dM = 1 x length(b) vector
else
    yp1=zeros(1,length(b));  %% 1 x dM = 1 x length(b) vector
    yp2=zeros(1,length(b));  %% 1 x dM = 1 x length(b) vector
end
yp1=yp1-msin(b_norm)*reshape([v_ZbCcomps.'; -1i*(v_ZbCcomps.')],1,[]);%% 1 x dM = 1 x length(b) vector
yprime1=z0*yp1;  %% nL x length(b);
yp2=yp2-mcos(b_norm)*reshape([v_ZbCcomps.'; -1i*(v_ZbCcomps.')],1,[]);%% 1 x dM = 1 x length(b) vector
yprime2=(ZbC*bC)*yp2;  %% nL x length(b);
yprime2=yprime2+(msin(b_norm)*(z0'*v)-mcos(b_norm)*(bC'*v_ZbCcomps))*...
    reshape([ZbC;1i*ZbC],length(ZbC(:,1)),[]); %% nL x length(b);
yprime=yprime1+yprime2; %% nL x length(b);
end
