function [x,fvalue,hist,bestvalue,bestx,accept_cross,total_cross,maxE,costcall,costflag]=...
    crossmove3(x,fvalue,bestvalue,bestx,hist,refden,accept_cross,total_cross,...
    maxE,lowE,range,scale,delta,temperature,seltem,Z,X,z0,ZbC,costcall,costflag)
%
%
% '%%%%%%%%% function crossmove3 %%%%%%%%%%%%%%%%%'

%rng(123,'twister');
sze=floor((maxE+range-lowE)*scale);
% pop=length(fvalue);
[pop,dim]=size(x);
fold=sum(fvalue);
a=(fold>maxE+range);
k1=a*sze+(1-a)*(fold>=lowE)*floor((fold-lowE)*scale);
% uniform selection
[pxy,G1,G2]=selection3(fvalue,pop,seltem);

% propose new solutions
e=x(G1,:)-x(G2,:);
s=e*e';
e=e/sqrt(s);
un=normrnd(0,1);
y2=x(G2,:)+un*e;
[fy2,~,~,~,costcall,costflag]=cost(y2,Z,X,z0,ZbC,costcall,costflag);
fnv=fvalue;
fnv(G2)=fy2;
fnew=fold-fvalue(G2)+fy2;
a=(fnew>maxE+range);
k2=a*sze+(1-a)*(fnew>=lowE)*floor((fnew-lowE)*scale);
r=hist(k1,2)-hist(k2,2)+(fold-fnew)/temperature;
accept=(k2<sze);
if accept==1 && r<=0.0
    accept=(unifrnd(0,1)<exp(r))*1;
end

if accept==1
    fvalue(G2)=fy2;
    x(G2,:)=y2;
    aux=hist(k2,2);
    hist(1:sze,2)=hist(1:sze,2)-delta*refden(1:sze)';
    hist(k2,2)=aux+delta*(1.0-refden(k2));
    hist(k2,3)=hist(k2,3)+1.0;
    accept_cross=accept_cross+1;
    total_cross=total_cross+1;
    maxE=min(maxE,fnew);
else  % accept==0
    aux=hist(k1,2);
    hist(1:sze,2)=hist(1:sze,2)-delta*refden(1:sze)';
    hist(k1,2)=aux+delta*(1.0-refden(k1));
    hist(k1,3)=hist(k1,3)+1.0;
    total_cross=total_cross+1;
end

if accept==1 && fy2<bestvalue
    bestvalue=fy2;
    bestx=y2;
end

% auxF=unifrnd(0,1);
% auxF
end
