function [x,fvalue,hist,bestvalue,bestx,accept_cross,total_cross,maxE,costcall,costflag]=...
    crossmove4(x,fvalue,bestvalue,bestx,hist,refden,accept_cross,total_cross,...
    maxE,lowE,range,scale,delta,temperature,seltem,Z,X,z0,ZbC,costcall,costflag)
%
%
%'%%%%%%%%% function crossmove4 %%%%%%%%%%%%%%%%%'

% rng(123,'twister');
sze=floor((maxE+range-lowE)*scale);
% pop=length(fvalue);
[pop,dim]=size(x);
fold=sum(fvalue);
a=(fold>maxE+range);
k1=a*sze+(1-a)*(fold>=lowE)*floor((fold-lowE)*scale);
% uniform selection
[pxy,G1,G2]=selection4(fvalue,pop,seltem);
un=unifrnd(0,1);
if un <0.5
    l1=floor(unifrnd(0,1)*(dim-1))+1;
    y1=[x(G1,1:l1) x(G2,(l1+1):dim)];
    y2=[x(G2,1:l1) x(G1,(l1+1):dim)];
else
    l1=floor(unifrnd(0,1)*(dim-1))+1;
    l2=l1;
    while l2==l1
        l2=floor(unifrnd(0,1)*(dim-1))+1;
    end
    tmp=max(l1,l2);
    l1=min(l1,l2);
    l2=tmp;
    y1=[x(G1,1:l1) x(G2,(l1+1):l2) x(G1,(l2+1):dim)];
    y2=[x(G2,1:l1) x(G1,(l1+1):l2) x(G2,(l2+1):dim)];
end
[fy1,~,~,~,costcall,costflag]=cost(y1,Z,X,z0,ZbC,costcall,costflag);
[fy2,~,~,~,costcall,costflag]=cost(y2,Z,X,z0,ZbC,costcall,costflag);

fnv=fvalue;
fnv(G1)=fy1;
fnv(G2)=fy2;
fnew=fold-fvalue(G1)-fvalue(G2)+fy1+fy2;
pyx=re_selection4(fnv,pop,G1,G2,seltem);
a=(fnew>maxE+range);
k2=a*sze+(1-a)*(fnew>=lowE)*floor((fnew-lowE)*scale);
r=hist(k1,2)-hist(k2,2)+(fold-fnew)/temperature+pyx-pxy;
accept=(k2<sze);
if accept==1 && r<=0.0
    accept=(unifrnd(0,1)<exp(r))*1;
end
if accept==1
    fvalue(G1)=fy1;
    fvalue(G2)=fy2;
    x(G1,:)=y1;
    x(G2,:)=y2;
    aux=hist(k2,2);
    hist(1:sze,2)=hist(1:sze,2)-delta*refden(1:sze)';
    hist(k2,2)=aux+delta*(1.0-refden(k2));
    hist(k2,3)=hist(k2,3)+1.0;
    accept_cross=accept_cross+1;
    total_cross=total_cross+1;
    maxE=min(maxE,fnew);
else  % accept==0
    aux=hist(k1,2);
    hist(1:sze,2)=hist(1:sze,2)-delta*refden(1:sze)';
    hist(k1,2)=aux+delta*(1.0-refden(k1));
    hist(k1,3)=hist(k1,3)+1.0;
    total_cross=total_cross+1;
end

if accept==1 && min(fy1,fy2)<bestvalue
    a=(fy1<=fy2); 
    bestvalue=a*fy1+(1-a)*fy2; 
    G=a*G1+(1-a)*G2;
    bestx=x(G,:);
end

% auxF=unifrnd(0,1);
% auxF
end


        
    
    