function z2=exp2DshapeC(z1,v)
%
    if length(z1) ~= length(v)
        error('z1 avd v must be complex vectors of the same length');
    end
    if abs(mean(z1))>0.0000000001 || (norm(z1)-1)>0.0000000001
        error('z1 is not a 2D preshape');
    end
    if abs(mean(v))>0.0000000001 || abs(z1'*v)>0.0000000001
        error('v is not a tangent vector to the preshape manifold at z1');
    end

    r=norm(v);
    if r == 0
        z2=z1;
    else
        z2=cos(r)*z1+(sin(r)/r)*v;
    end
end

    
    