function V=log2DshapeCvec(z1,Z2)
%
e=10^(-10);
if length(z1) ~= length(Z2(:,1))
    error('z1 and columns of  must be complex vectors of the same length');
end
if abs(mean(z1))>e || (norm(z1)-1)>e
    error('z1 is not a 2D preshape');
end
if sum(abs(mean(Z2))>e)>0 || sum((sqrt(diag(Z2'*Z2))-1)>e)>0
    error('one or more columns of Z2 are not 2D preshapes');
end

s=Z2'*z1; % inner products <z1,Z2>_C
as=abs(s);
Z2star=Z2*diag(s./as);
V=Z2star-z1*(as.');
normV=sqrt(diag(V'*V));
indx=(normV>e);
normVmodif=indx.*normV+(1-indx);
V=V*diag((acos(as).*indx)./normVmodif);
end

    
    