function [x,fvalue,hist,bestvalue,bestx,accept_loc,total_loc,maxE,costcall,costflag]=...
    metmove(x,fvalue,bestvalue,bestx,hist,refden,accept_loc,total_loc,maxE,...
    lowE,range,scale,stepsize,delta,temperature,Z,X,z0,ZbC,costcall,costflag)
%
%
% '%%%%%%%%% function metmove %%%%%%%%%%%%%%%%%'

% rng(123,'twister');
sze=floor((maxE+range-lowE)*scale);
locfreq=zeros(sze,1);
[pop,dim]=size(x);
e=zeros(1,dim);
fold=sum(fvalue);
a=(fold>maxE+range);
k1=a*sze+(1-a)*(fold>=lowE)*floor((fold-lowE)*scale);
%pop=length(fvalue);

for G=1:pop
    % propose a new solution;
    e=uniform_direction(dim);
    un=normrnd(0,1)*stepsize;
    y=x(G,:)+e*un;
    [fy,~,~,~,costcall,costflag]=cost(y,Z,X,z0,ZbC,costcall,costflag);
    fnew=fold-fvalue(G)+fy;
    a=(fnew>maxE+range);
    k2=a*sze+(1-a)*(fnew>=lowE)*floor((fnew-lowE)*scale);
    r=hist(k1,2)-hist(k2,2)+(fold-fnew)/temperature;
    accept=(k2<sze);
    if accept==1 && r<=0.0
        accept=accept*(unifrnd(0,1)<exp(r))*1;
    end

    if accept==1
        fvalue(G)=fy;
        x(G,:)=y;
        k1=k2;
        fold=fnew;
        locfreq(k2)=locfreq(k2)+1;
        accept_loc=accept_loc+1;
        if fy<bestvalue
            bestvalue=fy;
            bestx=y;
        end
    else
        locfreq(k1)=locfreq(k1)+1;
        total_loc=total_loc+1;
    end
end
locfreq=locfreq/G;
hist(1:sze,2)=hist(1:sze,2)+delta*(locfreq-refden(1:sze)');
hist(1:sze,3)=hist(1:sze,3)+locfreq;
maxE=min(maxE,fold);
    
% G
% auxF=unifrnd(0,1);
% auxF
end


        
    
    