function plot2DshapeC(zLdata,c,ls,lw)
%
% c  - line color;
% ls - line style;
% lw - line width
%

[nL,nSubj]=size(zLdata);
rLdata=reshape([real(zLdata); imag(zLdata)],nL,2,nSubj);

[nL,nCoord,nSubj]=size(rLdata);
aData=zeros(nL+1,nCoord,nSubj);
aData(1:nL,:,:)=rLdata;

for i=1:nSubj
    aData(nL+1,:,i)=rLdata(1,:,i);
end
%figure
subj=1;
plot(aData(:,1,subj),aData(:,2,subj),c,'LineStyle',ls,'LineWidth',lw);
axis equal
hold on
for i=2:nSubj
    plot(aData(:,1,i),aData(:,2,i),c,'LineStyle',ls,'LineWidth',lw);
end

end
