bestx=bEstI;
plot2DshapeC(vZ_mean,'b','-',0.5)
bestxC=coordR2coordC(bestx);
plot2DshapeC(ZbC*bestxC,'b','-',0.5)
plot2DshapeC([vZ_mean ZbC*bestxC],'b','-',0.5)
plot2DshapeC(exp2DshapeC(z0,vZ_mean),'b','-',0.5)
plot2DshapeC(exp2DshapeC(z0,ZbC*bestxC),'b','-',0.5)
plot2DshapeC([exp2DshapeC(z0,vZ_mean) exp2DshapeC(z0,ZbC*bestxC)],'b','-',0.5)

plot2DshapeC([vZ_mean exp2DshapeC(z0,vZ_mean)],'b','-',0.5)

figure
plot2DshapeC(Z,'b','-',0.5)
hold on;
plot2DshapeC(exp2DshapeC(z0,ZbC*bestxC),'r','-',3)


bestxC=coordR2coordC(bestx);
Z_mean_est=exp2DshapeC(z0,ZbC*bestxC);
Zstar2mean=z2STARz1(Z_mean_est,Z);
figure
plot2DshapeC(Zstar2mean,'b','-',0.5);
hold on;
plot2DshapeC(Z_mean_est,'g','-',3);



% Plot of the Log_{z0}-transformed data in T_{z0}M and its estimated mean
bestxC=coordR2coordC(bestx);
figure
plot2DshapeC(vZ,'r','-',0.5);
hold on;
plot2DshapeC(ZbC*bestxC,'g','-',3);


% Plot of the Z data in the shape space and the mapped back on M of the
% estimated mean of the Log_{z0}-transformed data in T_{z0}M; all of them
% rotated in their best positions toward z0
bestxC=coordR2coordC(bestx);
Z_mean_est=exp2DshapeC(z0,ZbC*bestxC);
Zstar2z0=z2STARz1(z0,Z);
[m,nSubj]=size(Z);
exp_vZ=Z*0;
for subj=1:nSubj
    exp_vZ(:,subj)=exp2DshapeC(z0,vZ(:,subj));
end
Z_mean_est_star2z0=z2STARz1(z0,Z_mean_est);
figure
plot2DshapeC(Z,'c','-',0.5);
hold on;
plot2DshapeC(vZ,'m','-',0.5);
plot2DshapeC(exp_vZ,'b','-',0.5);
plot2DshapeC(Z_mean_est,'y','-',3);
plot2DshapeC(ZbC*bestxC,'g','-',3);

figure
plot2DshapeC(Zstar2z0,'g','-',0.5);
hold on;
plot2DshapeC(exp_vZ,'m','-',0.5);



Z_mean=exp2DshapeC(z0,vZ_mean);
figure
plot2DshapeC(Z_mean,'m','-',0.5);
hold on;
plot2DshapeC(Z(:,5),'g','-',0.5);
Z5Star2Zmean=z2STARz1(Z_mean,Z(:,5));
plot2DshapeC(Z5Star2Zmean,'b','-',0.5);

plot2DshapeC(Z(:,250),'r','-',0.5);
[Z250rot,U]=spUnitaryGeodesic2DshapeC(Z_mean,Z(:,5),Z(:,250));
plot2DshapeC(Z250rot,'k','-',0.5);

[Z250rotrot,U1]=spUnitaryGeodesic2DshapeC(Z(:,5),Z_mean,Z250rot);
plot2DshapeC(Z250rotrot,'m','-',0.5);

figure
bestxC=coordR2coordC(bestx);
plot2DshapeC(exp2DshapeC(z0,ZbC*bestxC),'b','-',0.5)




% cost of zq in M
zq=exp2DshapeC(z0,vZ_mean)
dists=acos(abs(zq'*Z))
cost_expmean=dists*(dists.');



bestxC=coordR2coordC(bestx);
figure
plot2DshapeC(exp2DshapeC(z0,ZbC*bestxC),'b','-',1)
axis equal
plot2DshapeC(exp2DshapeC(z0,vZ_mean),'r','-',1)
vZ_mean_est=ZbC*bestxC;
Z_mean_est=exp2DshapeC(z0,ZbC*bestxC);
Z_vZ_mean=exp2DshapeC(z0,vZ_mean);
Zstar2mean=z2STARz1(Z_vZ_mean,Z_mean_est);
plot2DshapeC(Zstar2mean,'b','-',2)
wZstar2mean=log2DshapeC(z0,Zstar2mean);
beta_wZstar2mean=ZbC'*wZstar2mean;
wZ_vZ_mean=log2DshapeC(z0,Z_vZ_mean);
plot2DshapeC(exp2DshapeC(z0,wZstar2mean),'k','-',2)
plot2DshapeC(exp2DshapeC(z0,wZ_vZ_mean),'c','-',2)


plot(real(Z_mean_est(1)),imag(Z_mean_est(1)),'m+')
plot(real(Z_mean_est(2)),imag(Z_mean_est(2)),'k+')
plot(real(Z_mean_est(3)),imag(Z_mean_est(3)),'r+')
plot(real(Z_mean_est(50)),imag(Z_mean_est(50)),'c+')
plot(real(Z_vZ_mean(1)),imag(Z_vZ_mean(1)),'m+')
plot(real(Z_vZ_mean(2)),imag(Z_vZ_mean(2)),'k+')
plot(real(Z_vZ_mean(3)),imag(Z_vZ_mean(3)),'r+')
plot(real(Z_vZ_mean(50)),imag(Z_vZ_mean(50)),'c+')

plot2DshapeC(Z(:,1),'k','-',1)
plot(real(Z(1,1)),imag(Z(1,1)),'m+')
plot(real(Z(2,1)),imag(Z(2,1)),'k+')
plot(real(Z(3,1)),imag(Z(3,1)),'r+')
plot(real(Z(50,1)),imag(Z(50,1)),'c+')

indP=[1:3 50]
[Z_vZ_mean(indP) Z_mean_est(indP)];
[vZ_mean(indP) vZ_mean_est(indP)];

figure
plot2DshapeC(vZ_mean_est,'b','-',0.5)
plot2DshapeC(vZ_mean,'r','-',0.5)
plot2DshapeC(wZstar2mean,'g','-',0.5)
plot2DshapeC(wZ_vZ_mean,'m','-',0.5)
theta=angle(vZ_mean_est'*vZ_mean/abs(vZ_mean_est'*vZ_mean));
plot2DshapeC(exp(1i*theta)*vZ_mean_est,'g','-',0.5)

figure
plot2DshapeC(exp2DshapeC(z0,exp(1i*theta)*vZ_mean_est),'m','-',1)

Zmean=mean(Z.').';
plot2DshapeC(Zmean,'m','-',2)
plot(Zmean(1),'m+')
plot(Zmean(2),'k+')
plot(Zmean(3),'r+')
plot(Zmean(50),'c+')

dists1=acos(abs(Zmean'*Z));
cost_Zmean=dists1*(dists1.');

